"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  version: true,
  Config: true,
  Server: true,
  FederationServer: true,
  FEDERATION_RESPONSE_MAX_SIZE: true,
  StellarTomlResolver: true,
  STELLAR_TOML_MAX_SIZE: true,
  HorizonAxiosClient: true,
  SERVER_TIME_MAP: true,
  getCurrentServerTime: true
};
Object.defineProperty(exports, "Config", {
  enumerable: true,
  get: function get() {
    return _config.Config;
  }
});
Object.defineProperty(exports, "FEDERATION_RESPONSE_MAX_SIZE", {
  enumerable: true,
  get: function get() {
    return _federation_server.FEDERATION_RESPONSE_MAX_SIZE;
  }
});
Object.defineProperty(exports, "FederationServer", {
  enumerable: true,
  get: function get() {
    return _federation_server.FederationServer;
  }
});
Object.defineProperty(exports, "HorizonAxiosClient", {
  enumerable: true,
  get: function get() {
    return _horizon_axios_client.default;
  }
});
Object.defineProperty(exports, "SERVER_TIME_MAP", {
  enumerable: true,
  get: function get() {
    return _horizon_axios_client.SERVER_TIME_MAP;
  }
});
Object.defineProperty(exports, "STELLAR_TOML_MAX_SIZE", {
  enumerable: true,
  get: function get() {
    return _stellar_toml_resolver.STELLAR_TOML_MAX_SIZE;
  }
});
Object.defineProperty(exports, "Server", {
  enumerable: true,
  get: function get() {
    return _server.Server;
  }
});
Object.defineProperty(exports, "StellarTomlResolver", {
  enumerable: true,
  get: function get() {
    return _stellar_toml_resolver.StellarTomlResolver;
  }
});
exports.default = void 0;
Object.defineProperty(exports, "getCurrentServerTime", {
  enumerable: true,
  get: function get() {
    return _horizon_axios_client.getCurrentServerTime;
  }
});
exports.version = void 0;
var _horizon_api = require("./horizon_api");
Object.keys(_horizon_api).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _horizon_api[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _horizon_api[key];
    }
  });
});
var _server_api = require("./server_api");
Object.keys(_server_api).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _server_api[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _server_api[key];
    }
  });
});
var _account_response = require("./account_response");
Object.keys(_account_response).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _account_response[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _account_response[key];
    }
  });
});
var _errors = require("./errors");
Object.keys(_errors).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _errors[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _errors[key];
    }
  });
});
var _config = require("./config");
var _server = require("./server");
var _federation_server = require("./federation_server");
var _stellar_toml_resolver = require("./stellar_toml_resolver");
var _horizon_axios_client = _interopRequireWildcard(require("./horizon_axios_client"));
var _utils = require("./utils");
Object.keys(_utils).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _utils[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _utils[key];
    }
  });
});
var _jsStellarBase = require("@digitalbits-blockchain/js-stellar-base");
Object.keys(_jsStellarBase).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  if (key in exports && exports[key] === _jsStellarBase[key]) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _jsStellarBase[key];
    }
  });
});
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
var version = exports.version = require("../package.json").version;
var _default = exports.default = module.exports;